﻿using System.IO;
using System.Reflection;

namespace E39
{
    public class Resources
    {
        /// <summary>
        /// Return the absolute path of a program file, that is, a file within the directory where the compiled assembly and other binary program files are localized.
        /// </summary>
        /// <param name="filename">The filename relative to the binary directory. Can also be multiple strings to combine to a filename path.</param>
        /// <returns>The absolute path of a program file.</returns>
        public static string GetPathOfProgramFile(params string[] filename)
        {
            // Get path of current assembly, get directory of that path, and combine with supplied file name
            return Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), Path.Combine(filename));
        }
    }
}
