﻿using E39;
using NUnit.Framework;
using System.IO;
using System.Reflection;

namespace E39_Tests
{
    class ResourcesTests
    {
        [Test]
        public void GetPathOfProgramFile_PathOfScript_DirectoryMatchesAssemblyPath()
        {
            // Arrange
            var expectedProgramFilesDirPath = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);

            // Act
            var scriptPath = Resources.GetPathOfProgramFile("NetCDFConverter.py");

            // Assert
            var scriptDirPath = Path.GetDirectoryName(scriptPath);
            Assert.AreEqual(expectedProgramFilesDirPath, scriptDirPath);
        }

        [Test]
        public void GetPathOfProgramFile_PathOfTestDataFile_PathMatches()
        {
            // Arrange
            var expectedFilePath = Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), "data", "test_data.nc");

            // Act
            var testDataFilePath = Resources.GetPathOfProgramFile("data", "test_data.nc");

            // Assert
            Assert.AreEqual(expectedFilePath, testDataFilePath);
        }
    }
}
