﻿using E39.WebApplication.Jobs;
using System;
using System.Threading.Tasks;

namespace E39.WebApplication.Hubs
{
    /// <summary>
    /// Methods which can be called on clients of the <see cref="JobHub"/>.
    /// </summary>
    public interface IJobHubClient
    {
        Task JobProgressChanged(Guid jobId, JobProgressChangedEventArgs eventArgs);

        Task JobStateChanged(Guid jobId, JobStateChangedEventArgs eventArgs);

        Task JobTimeFinishedEstimated(Guid jobId, JobTimeFinishedEstimatedEventArgs eventArgs);

        Task JobMessageAdded(Guid jobId, JobMessageAddedEventArgs eventArgs);

        Task ReceiveAllJobInfo(Guid jobId, JobHub.JobInfoDTO jobInfo);
    }
}