﻿using System;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;

namespace E39.WebApplication.Migrations
{
    public partial class InitialCreate : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "LoadTimes",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn),
                    DownloadCsvFileFromAzure = table.Column<long>(nullable: false),
                    DownloadNetCDFFileFromAzure = table.Column<long>(nullable: false),
                    ConvertNetCDFFilesInParallel = table.Column<long>(nullable: false),
                    UploadCsvFileToAzure = table.Column<long>(nullable: false),
                    DownloadFromMetConvertAndUploadToAzure = table.Column<long>(nullable: false),
                    DownloadTemplates = table.Column<long>(nullable: false),
                    LoadCsvFile = table.Column<long>(nullable: false),
                    ImputeDatatable = table.Column<long>(nullable: false),
                    LoadExcelTemplates = table.Column<long>(nullable: false),
                    WriteToExcel = table.Column<long>(nullable: false),
                    SaveExcelFiles = table.Column<long>(nullable: false),
                    StoreReportsInDb = table.Column<long>(nullable: false),
                    CreateZipFile = table.Column<long>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_LoadTimes", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "RawDataFiles",
                columns: table => new
                {
                    Filename = table.Column<string>(nullable: false),
                    DateChanged = table.Column<DateTimeOffset>(nullable: false),
                    DateCached = table.Column<DateTimeOffset>(nullable: false),
                    UploadedBy = table.Column<string>(nullable: true),
                    ManuallyUploaded = table.Column<bool>(nullable: false, defaultValue: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_RawDataFiles", x => x.Filename);
                });

            migrationBuilder.CreateTable(
                name: "Reports",
                columns: table => new
                {
                    Filename = table.Column<string>(nullable: false),
                    DateCreated = table.Column<DateTimeOffset>(nullable: false),
                    CreatedBy = table.Column<string>(nullable: true),
                    Status = table.Column<string>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Reports", x => x.Filename);
                });

            migrationBuilder.CreateTable(
                name: "ReportRawDataFiles",
                columns: table => new
                {
                    ReportFilename = table.Column<string>(nullable: false),
                    RawDataFileFilename = table.Column<string>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ReportRawDataFiles", x => new { x.ReportFilename, x.RawDataFileFilename });
                    table.ForeignKey(
                        name: "FK_ReportRawDataFiles_RawDataFiles_RawDataFileFilename",
                        column: x => x.RawDataFileFilename,
                        principalTable: "RawDataFiles",
                        principalColumn: "Filename",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_ReportRawDataFiles_Reports_ReportFilename",
                        column: x => x.ReportFilename,
                        principalTable: "Reports",
                        principalColumn: "Filename",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_ReportRawDataFiles_RawDataFileFilename",
                table: "ReportRawDataFiles",
                column: "RawDataFileFilename");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "LoadTimes");

            migrationBuilder.DropTable(
                name: "ReportRawDataFiles");

            migrationBuilder.DropTable(
                name: "RawDataFiles");

            migrationBuilder.DropTable(
                name: "Reports");
        }
    }
}
