﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;

namespace E39.WebApplication.Models
{
    public class RawDataFile
    {
        [Key]
        public string Filename { get; set; }

        [DisplayFormat(DataFormatString = "{0:dd-MM-yyyy HH:mm:ss} UTC")]
        public DateTimeOffset DateChanged { get; set; }

        [DisplayFormat(DataFormatString = "{0:dd-MM-yyyy HH:mm:ss} UTC")]
        public DateTimeOffset DateCached { get; set; }

        public string UploadedBy { get; set; }
        public bool ManuallyUploaded { get; set; }

        public ICollection<ReportRawDataFile> ReportRelations { get; set; }

        public RawDataFile()
        {
        }

        public RawDataFile(string filename, DateTimeOffset dateChanged, DateTimeOffset dateCached, string uploadedBy, bool manuallyUploaded)
        {
            Filename = filename;
            DateChanged = dateChanged;
            DateCached = dateCached;
            UploadedBy = uploadedBy;
            ManuallyUploaded = manuallyUploaded;
        }

        public override string ToString()
        {
            return $"RawDataFile: Filename={Filename}, DateChanged={DateChanged}, DateCached={DateCached}, UploadedBy={UploadedBy}, ManuallyUploaded={ManuallyUploaded}, ReportRelations ={(ReportRelations == null ? null : string.Join(", ", ReportRelations.Select(r => r.Report)))}";
        }
    }
}