﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace E39.WebApplication.Models
{
    public class Report
    {
        [Key]
        public string Filename { get; set; }

        [DisplayFormat(DataFormatString = "{0:dd-MM-yyyy HH:mm:ss} UTC")]
        public DateTimeOffset DateCreated { get; set; }

        public string CreatedBy { get; set; }
        public string Status { get; set; }

        public ICollection<ReportRawDataFile> RawDataFilesRelations { get; set; }

        public Report()
        {
        }

        public Report(string filename, DateTimeOffset dateCreated, string createdBy, string status)
        {
            Filename = filename;
            DateCreated = dateCreated;
            CreatedBy = createdBy;
            Status = status;
        }

        public override string ToString()
        {
            return $"Report: Filename={Filename}, DateCreated={DateCreated}, CreatedBy={CreatedBy}, Status={Status}, RawDataFilesRelations={RawDataFilesRelations?.Count}";
        }
    }
}