﻿$(function () {
    /* Download a report when download button is pressed. */
    $(document).on('click', '.download-button', function () {
        let reportName = $(this).data('report-name');
        window.open('/StoredReports/' + reportName, '_blank');
    });

    /* AJAX for deleting a report when delete button is pressed inside the modal. */
    $('#delete-button-modal').click(function () {
        $.ajax({
            url: '/StoredReports/' + encodeURIComponent($(this).data('delete-report-name')),
            type: 'DELETE',
            headers: {
                'X-CSRF-Token': antiXsrfRequestToken
            },
            success: function (result) {
                location.reload();
                console.log(result);
            }
        });
    });

    /* Shows popover when mouse hovers over question mark icon. Fill the popover with html from the popover-content div. */
    $('#report-status-icon').mouseover(function () {
        $('#report-status-info-popover').popover({
            html: true,
            content: function () {
                return $('#popover-content').html();
            }
        });

        $('#report-status-info-popover').popover('show');
    });

    /* Hides the popver when mouse leaves the question mark icon. */
    $('#report-status-icon').mouseleave(function () {
        $('#report-status-info-popover').popover('hide');
    });

    /* Show the name and date of the report in the delete modal when it opens */
    $('#delete-report-modal').on('show.bs.modal', function (event) {
        let button = $(event.relatedTarget);
        let reportName = button.data('report-name');
        let reportDate = button.data('report-date');
        let modal = $(this);
        modal.find('.modal-body').text('Are you sure you want to delete «' + reportName + '», created ' + reportDate + '?');
        modal.find('#delete-button-modal').data('delete-report-name', reportName);
    });
});