﻿$(function () {
    bsCustomFileInput.init();

    /* Download a raw data file when download button is pressed. */
    $(document).on('click', '.download-button', function () {
        let filename = $(this).data('filename');
        window.open('/RawDataFiles/' + encodeURIComponent(filename), '_blank');
    });

    /* AJAX for deleting a raw data file when delete button is pressed inside the modal. */
    $('#delete-button-modal').click(function () {
        $.ajax({
            url: '/RawDataFiles/' + encodeURIComponent($(this).data('delete-filename')),
            type: 'DELETE',
            headers: {
                'X-CSRF-Token': antiXsrfRequestToken
            },
            success: function (result) {
                console.log(result);
                location.reload();
            }
        });
    });

    /* Show the name and date of the report in the delete modal when it opens */
    $('#delete-file-modal').on('show.bs.modal', function (event) {
        let button = $(event.relatedTarget);
        let filename = button.data('filename');
        let fileCached = button.data('file-cached');
        let modal = $(this);
        modal.find('.modal-body').text('Are you sure you want to delete «' + filename + '», uploaded ' + fileCached + '?');
        modal.find('#delete-button-modal').data('delete-filename', filename);
    });
});

/* Function for uploading files after files are chosen by the user. */
function uploadFiles() {
    $('#uploading-progress-message').css('visibility', 'visible');
    $('#files-input').attr('disabled', true);

    let input = $('#files-input')[0];
    let files = input.files;
    let formData = new FormData();

    for (let i = 0; i != files.length; i++) {
        formData.append('files', files[i]);
    }

    $.ajax({
        url: '/RawDataFiles',
        data: formData,
        processData: false,
        contentType: false,
        type: 'POST',
        headers: {
            'X-CSRF-Token': antiXsrfRequestToken
        },
        success: function (data) {
            console.log(data);
            $('#uploading-progress-message').css('visibility', 'hidden');
            $('#files-input-label').text('Upload completed');
            $('#files-input').attr('disabled', false);
        }
    });
}